#ifndef STACK_HPP_INCLUDED
#define STACK_HPP_INCLUDED

template <class T> // elemtpus sablonja
class Stack // verem tpus
{
    private:
        T _values[100]; // rtkek tmbje
        int _top; // a tetelem indexe
    public:
        enum Exceptions { STACK_FULL, STACK_EMPTY }; // kivtelek felsorolsi tpusa

        Stack(); // konstruktor
        bool isEmpty() const; // res-e a verem
        bool isFull() const; // tele van-e a verem
        void push(T value); // elem behelyezse
        T pop(); // elem kivtele
        T top() const; // tetelem lekrdezse
        void clear(); // elemek trlse
        int size() const; // mret lekrdezse
};

template <class T>
Stack<T>::Stack()
{
    _top = 0; // kezdetben 0 elem van a veremben
}

template <class T>
bool Stack<T>::isEmpty() const
{
    return _top == 0;
}

template <class T>
bool Stack<T>::isFull() const
{
    return _top == 100;
}

template <class T>
void Stack<T>::push(T value)
{
    if (_top < 100) // ha mg van hely
    {
        _values[_top] = value; // behelyezzk az elemet
        _top++; // nveljk az elemszmot
    }
    else // klnben kivtelt dobunk
        throw STACK_FULL;
}

template <class T>
T Stack<T>::pop()
{
    if (_top > 0) // ha van elem
    {
        _top--; // cskkentjk az elemszmot
        return _values[_top]; // visszaadjuk a kivett elemet
    }
    else // klnben kivtelt dobunk
        throw STACK_EMPTY;
}

template <class T>
T Stack<T>::top() const
{
    if (_top > 0) // ha van elem
        return _values[_top - 1];
    else // klnben kivtelt dobunk
        throw STACK_EMPTY;
}

template <class T>
void Stack<T>::clear()
{
    _top = 0;
}

template <class T>
int Stack<T>::size() const
{
    return _top;
}

#endif // STACK_HPP_INCLUDED
